searchNodes=[{"doc":"Starchoice takes his name from the satellite tv company (now called Shaw Direct) because they are selling TV decoders. Since this lib is used to declare map decoders, I thought it felt appropriate to be named that way. Maybe not. Anyway.The goal of the library is to provide a streamline process for convertir String keyed maps to well defined structures. It is highly inspired by Elm's JSON decoders where you create different JSON decoders for the same data type.For more information about creating decoder, visit the Starchoice.Decoder module documentation.","ref":"Starchoice.html","title":"Starchoice","type":"module"},{"doc":"Decodes a map into a {:ok, _} | {:error | _} tuple format. It accepts the same options and parameters as decode!/3","ref":"Starchoice.html#decode/3","title":"Starchoice.decode/3","type":"function"},{"doc":"Decodes a map into according to the given decoder. A decoder can either be a %Starchoice.Decoder{}, a one or two arity function that returns a decoder or a module implementing Starchoice.Decoder.See module Starchoice.Decoder for more information about decoders.Examplesiex&gt; decoder = %Decoder{struct: User, fields: [first_name: [], age: [with: &amp;String.to_integer/1]]} iex&gt; Decoder.decode!(%{&quot;first_name&quot; =&gt; &quot;Bobby Hill&quot;, &quot;age&quot; =&gt; &quot;13&quot;}, decoder) %User{first_name: &quot;Bobby Hill&quot;, age: 13}If the module User implements Starchoice.Decoder, it can be used directlyiex&gt; Decoder.decode!(%{&quot;first_name&quot; =&gt; &quot;Bobby Hill&quot;, &quot;age&quot; =&gt; &quot;13&quot;}, User) iex&gt; Decoder.decode!(%{&quot;first_name&quot; =&gt; &quot;Bobby Hill&quot;, &quot;age&quot; =&gt; &quot;13&quot;}, {User, :default}) # same as above","ref":"Starchoice.html#decode!/3","title":"Starchoice.decode!/3","type":"function"},{"doc":"","ref":"Starchoice.html#t:decode_option/0","title":"Starchoice.decode_option/0","type":"type"},{"doc":"","ref":"Starchoice.html#t:decoder/0","title":"Starchoice.decoder/0","type":"type"},{"doc":"This module can be used from two different ways:As a macroManuallyAs a macroTo be defining decoders as macro, you need to use the Starchoice.Decoder module in your struct. It's declaration is highly (like totally) inspired by Ecto's schemas.To see available options, take a look at put_field/3's documentationExamplesdefmodule User do use Starchoice.Decoder defstruct first_name: nil, age: nil defdecoder do field(:first_name) field(:age) end end User.__decoder__() # %Decoder{} User.__decoder__(:default) # %Decoder{}When you don't pass a name to the defdecoder/2 function, it defaults to default. So calling defdecoder do and defdecoder :default do is identical. This is because you might be interested in creating multiple decoders for the same struct like below:defmodule User do use Starchoice.Decoder defstruct first_name: nil, last_name: nil, email: nil, age: nil defdecoder do field(:first_name) field(:age) end defdecoder :full do field(:first_name) field(:last_name) field(:email) field(:age) end end User.__decoder__() # %Decoder{fields: [{:first_name, _}, {:age, _}]} User.__decoder__(:default) # %Decoder{fields: [{:first_name, _}, {:age, _}]} User.__decoder__(:full) # %Decoder{fields: [{:first_name, _}, {:last_name, _}, {:email, _}, {:age, _}]}And you can now use the module directly when calling Starchoice.decode/3 like:iex&gt; Starchoice.decode(input, User) iex&gt; Starchoice.decode(input, {User, :full})ManuallyYou could also build decoder manually like the following:defmodule User do defstruct email: nil, password: nil def mask_password(_), do: &quot;MASKED&quot; end User |&gt; Decoder.new() |&gt; Decoder.put_field(:email) |&gt; Decoder.put_field(:password, with: &amp;User.mask_password/1) # or Decoder.new(User, [ {:email, []}, {:password, with: &amp;User.mask_password/1} ])To see available options, take a look at put_field/3's documentation","ref":"Starchoice.Decoder.html","title":"Starchoice.Decoder","type":"behaviour"},{"doc":"","ref":"Starchoice.Decoder.html#c:__decoder__/1","title":"Starchoice.Decoder.__decoder__/1","type":"callback"},{"doc":"","ref":"Starchoice.Decoder.html#defdecoder/2","title":"Starchoice.Decoder.defdecoder/2","type":"macro"},{"doc":"","ref":"Starchoice.Decoder.html#field/2","title":"Starchoice.Decoder.field/2","type":"macro"},{"doc":"Initiates a new Decoder, you can pass a list of fields with options.To see available options, take a look at put_field/3's documentation","ref":"Starchoice.Decoder.html#new/2","title":"Starchoice.Decoder.new/2","type":"function"},{"doc":"Puts a field decoding in the decoder. Available options are::required: Defines if a field is required, will caused a raise (or {:error, _} tuple) when the required field isn't present:default: Specifies a fallback value in case the field is missing (can't be used with required: true):with: Specifies a decoder the decode the given field. Like the Starchoice.decode/3 call, it can support any valid decoder in Module, {Module, :decoder} and a function.:sanitize: Specifies a sanitizer. By default, the value is sanitized by trimming the value and casting to nil if the value is &quot;&quot;. Can either be a boolean or a function.","ref":"Starchoice.Decoder.html#put_field/3","title":"Starchoice.Decoder.put_field/3","type":"function"},{"doc":"","ref":"Starchoice.Decoder.html#t:decoder_struct/0","title":"Starchoice.Decoder.decoder_struct/0","type":"type"},{"doc":"","ref":"Starchoice.Decoder.html#t:field_definition/0","title":"Starchoice.Decoder.field_definition/0","type":"type"},{"doc":"","ref":"Starchoice.Decoder.html#t:field_option/0","title":"Starchoice.Decoder.field_option/0","type":"type"},{"doc":"","ref":"Starchoice.Decoder.html#t:t/0","title":"Starchoice.Decoder.t/0","type":"type"}]